/* $Id: libperfctr.h,v 1.4 2000/08/31 22:32:06 mikpe Exp $
 * Library interface to Linux x86 Performance-Monitoring Counters.
 *
 * Copyright (C) 1999-2000  Mikael Pettersson
 */

#ifndef __LIB_PERFCTR_H
#define __LIB_PERFCTR_H

#include "linux/perfctr.h"

/*
 * Invokes the kernel driver directly.
 */

extern int perfctr_syscall(unsigned cmd, long arg);

/*
 * Operations on the process' own virtual-mode perfctrs.
 */

struct vperfctr;	/* opaque; users only see pointers to these */

extern struct vperfctr *vperfctr_attach(void);
extern unsigned long long vperfctr_read_one(const struct vperfctr*, int);
extern int vperfctr_read_state(const struct vperfctr*, struct vperfctr_state*);
extern int vperfctr_control(const struct vperfctr*, struct perfctr_control*);
extern int vperfctr_stop(const struct vperfctr*);
extern int vperfctr_unlink(const struct vperfctr*);
extern void vperfctr_close(struct vperfctr*);

/*
 * Operations on global-mode perfctrs.
 */

extern int perfctr_global_control(struct gperfctr_control*);
extern int perfctr_global_read(struct gperfctr_state*);
extern int perfctr_global_stop(void);

/*
 * Miscellaneous operations.
 */

extern int perfctr_info(struct perfctr_info*);
extern unsigned perfctr_cpu_nrctrs(void);
extern const char *perfctr_cpu_name(void);
extern unsigned perfctr_evntsel_num_insns(void);

#endif /* __LIB_PERFCTR_H */
