#pragma	ident	"@(#)perfmon_lib.s 1.1	97/04/20 SMI"

#include <sys/asm_linkage.h>
#include "perfmon.h"

	!
	! extern void clr_pic(void);
	!
	! Clear the PIC counters.  However, only read-to-read values
	! are guaranteed to be accurate.
	.align 64		! Align this function on a 64-byte boundry
	.global	clr_pic
	ENTRY(clr_pic)
	wr	%g0, %pic	! Clear the PIC register
	rd	%pic, %g0       ! This needs to be here.  Trust me.  :)
	retl			! Return to the caller
	  nop			! Delay slot.  Needs to be empty this time.
	SET_SIZE(clr_pic)

	!
	! extern void cpu_sync(void);
	!
	! Make sure all instructinos and memory references before us
	! have been completed.
	.global cpu_sync
	ENTRY(cpu_sync)
	membar	#Sync		! Wait for all outstanding things to finish
	retl			! Return to the caller
	  nop			! Delay slot
	SET_SIZE(cpu_sync)

	!
	! extern unsigned long long get_tick(void)
	!
	! Read the tick register and return it
	.global get_tick
	ENTRY(get_tick)
	rd	%tick, %o0	! Get the current value of TICK
	clruw   %o0, %o1	! put the lower 32 bits into %o1
	retl			! Return to the caller
	  srlx  %o0, 32, %o0    ! put the upper 32 bits into %o0
	SET_SIZE(get_tick)

	!
	! extern unsigned long long get_pic(void)
	!
	! Get both PIC0 and PIC1 atomically
	.global get_pic
	ENTRY(get_pic)
	rd	%pic, %o0	! Get the value of both PIC0 and PIC1
	clruw   %o0, %o1	! Put the lower 32 bits (PIC0) into %o1
	retl			! Return to the caller
	  srlx  %o0, 32, %o0	! put the upper 32 bits (PIC1) into %o0
	SET_SIZE(get_pic)

	!
	! extern unsigned long get_pic0(void)
	!
	! Get the value in PIC0
	.global get_pic0
	ENTRY(get_pic0)
	rd	    %pic, %o0	! Get the value of both PIC0 and PIC1
	retl			! Return to the caller
	  clruw   %o0, %o0	! Put the lower 32 bits (PIC0) into %o0
	SET_SIZE(get_pic0)

	!
	! extern unsigned long get_pic1(void)
	!
	! Get the value in PIC1
	.global get_pic1
	ENTRY(get_pic1)
	rd	    %pic, %o0	! Get the value of both PIC0 and PIC1
	retl			! Return to the caller
	  srlx    %o0, 32, %o0	! Put the upper 32 bits (PIC1) into %o0
	SET_SIZE(get_pic1)

	!
	! extern long extract_pic0(unsigned long long);
	!
	! Given PIC, get PIC.D0
	.global extract_pic0
	ENTRY(extract_pic0)
	mov	    %o1, %o0	! move the lower 32 bits to %o0
	retl			! Return to the caller
	  mov	    %g0, %o1	! clear %o1
	SET_SIZE(extract_pic0)

	!
	! extern long extract_pic1(unsigned long long);
	!
	! Given PIC, get PIC.D1
	.global extract_pic1
	ENTRY(extract_pic1)
	retl			! Return to the caller
	  mov	    %g0, %o1	! The upper 32 bits are in %o0.  Clear %o1
	SET_SIZE(extract_pic1)
